#include <stdio.h>
#include <unistd.h>

#define LEVELS 3
#define TRUE 1
#define FALSE 0

/* Current identifier */
int id;

int main()
{
  int pid1, pid2;
  int stop = FALSE;
  int i;
  id = 0;
  pid1 = pid2 = 0;
  for (i=1; i < LEVELS && !stop; i++) {
    pid1 = fork();
    if (pid1 < 0) {
      /* Error */
      perror("Bad fork");
      exit(1);
    } else if (pid1 > 0) {
      pid2 = fork();
      if (pid2 < 0) {
        /* Error */
        perror("Bad fork");
        exit(1);
      } else if (pid2 > 0) {
        stop = TRUE;
      } else {
			  id = i;
        pid1 = 0;
      }
    } else {
		  id = i;
		}
  }
  printf("My data: id %d, pid %d, child pids %d %d\n", id, getpid(), pid1, pid2);

}
